//RACN[ht@C
#include "Core/nomfc_core.h"
#include "Core/util.h"

//\[Xt@C
#include "resource.h"

//n[hR[fBOp[^()
#define REF_INTERVAL        17      //ʍXVԊu[ms]
#define FIELD_CX            96      //tB[h
#define FIELD_CY            144     //tB[h
#define APPSAND_MAX         300     //ŗ闱
#define COLORMIX_FRAME      2       //Fꐢiނ̂ɂt[
#define RAINBOWPOINT_MAX    32      //1FrameœɋN锽_̍ő吔

#define HUETUNE_BASE        10      //Ŝ̐F␳ll
#define HUETUNE_B           20      //Blue   ␳ll
#define HUETUNE_C           -20     //Cyan   ␳ll
#define HUETUNE_G           -10     //Green  ␳ll
#define HUETUNE_Y           -30     //Yellow ␳ll
#define HUETUNE_R           10      //Red    ␳ll
#define HUETUNE_M           10      //Magenta␳ll

//CBitmap
#include "bitmap.h"

//HLSvZ֐
#include "color.h"

//{NX
#include "interface.h"

//tB[h}bvNX
#include "FieldMap.h"

//--------------------------------------------------------------------------------
//  CvO
//--------------------------------------------------------------------------------
class CMainApp : public CCore
{
//--------------------------------------------------
//  member value
//--------------------------------------------------
private:
    int             m_iNextColor;       //̐F
    CFieldMap       m_Field;            //tB[h}bv
    CScoreManager   m_Score;            //XRAǗ
    CBackSurface    m_BackGround[2];    //Xe[Wwi
    CBackSurface    m_Surface;          //C[WǗ

public:
    CMainApp()
    {
    }

//--------------------------------------------------
//  main routine
//--------------------------------------------------
public:
    // ŏɌĂ΂
    BOOL Init()
    {
        //̏
        srandMT((DWORD)time(NULL));

        //
        if (!LoadData())    return FALSE;
        if (!InitData())    return FALSE;
        if (!InitWindow())  return FALSE;

        return TRUE;
    }

    // ŌɌĂ΂
    BOOL Exit()
    {
        return TRUE;
    }

    // 1Frm ɌĂ΂
    BOOL Run()
    {
        // s
        m_Field.Run();
        m_Score.Bonus(m_Field.GetReactionPoint());

        // BackSurface `
        m_BackGround[1].Draw();
        m_Field.Draw();
        m_Field.DrawCursor(m_backsurf.hDC, m_iNextColor);

        // Swap
        InvalidateRect(NULL, FALSE);

        return TRUE;
    }

    // ɂȎɌĂ΂
    BOOL Idle()
    {
        return TRUE;
    }

    // Window Procedure
    BOOL Proc(HWND hWnd, UINT WM, WPARAM wP, LPARAM lP)
    {
        if (WM == WM_PAINT)           return CallPaint();   //`惁bZ[W̏
        if (ProcSubMouse(WM, wP, lP)) return TRUE;          //}EX֘AbZ[W̏
        return FALSE;
    }

//--------------------------------------------------
//  Message Handler
//--------------------------------------------------
protected:
    void OnMouseMove(int x, int y)
    {
        m_Field.CalcCursor(x, y);
    }

    void OnLButtonDown(int x, int y)
    {
        if (m_Score.IsGameOver()) {
            InitData();
        } else {
            m_Field.CalcCursor(x, y);
            if (m_Field.FloodBead(m_iNextColor, APPSAND_MAX)) {
                NextColor();
            }
        }
    }
    
    void OnRButtonDown(int x, int y)
    {
        m_Score.GameOver();
    }
    
    void OnPaint(HDC wndDC)
    {
        m_Score.Draw(wndDC);
    }

//--------------------------------------------------
//  Initialize
//--------------------------------------------------
private:
    // Load Data
    BOOL LoadData()
    {
        if (!m_Field.Allocate(FIELD_CX, FIELD_CY)) return FALSE;
        if (!m_BackGround[0].LoadSurface("back1_sml.bmp")) return FALSE;
        if (!m_BackGround[1].LoadSurface("back2_sml.bmp")) return FALSE;
        m_BackGround[0].Stretch(384, 576);
        m_BackGround[1].Stretch(384, 576);
        return TRUE;
    }

    // Initialize Data
    BOOL InitData()
    {
        m_Field.Init();
        m_Score.Init();
        NextColor();

        return TRUE;
    }

    // Window
    BOOL InitWindow()
    {
        //EBhȆ傫ݒ
        m_param.cs.cx = FIELD_CX * 4+64;
        m_param.cs.cy = FIELD_CY * 4+64;

        //EBhEݒ
        m_param.ref_interval = REF_INTERVAL;
        strcpy(m_param.strWindowTitle, "F̍");
        strcpy(m_param.strClassName, "NIJIIROBEAD");
        m_param.hIcon = LoadIcon(hInst, MAKEINTRESOURCE(IDI_MAIN));

        //obNT[tBX̍쐬
        if (!CreateBackSurface(m_param.cs.cx, m_param.cs.cy, 0, TRUE)) return FALSE;
        ICanDraw::SetScreenAddress(m_backsurf.pBits, m_param.cs.cx*3, m_param.cs.cy);

        m_Field.SetPosition(32, 32);
        m_BackGround[0].SetTexturePosition(0, 0, 384, 576);
        m_BackGround[0].SetPosition(32, 32);
        m_BackGround[1].SetTexturePosition(0, 0, 384, 576);
        m_BackGround[1].SetPosition(32, 32);

        return TRUE;
    }

//--------------------------------------------------
//  Run
//--------------------------------------------------
private:
    // Fݒ
    void NextColor()
    {
        m_iNextColor = randMT() & 0x7f;
    }
};

CMainApp theApp;
